#include <stdio.h>
#include <fcntl.h>
#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <time.h>

FILE *fpOutRaw;
FILE *fpOutStrip;


void strip(char *result, int n){
  
  char out[256];
  int flag0, flag1;
  int t, th, tm, ts;
  float alt;
  float lad, lng;
  int i;

  flag0 = -9;
  flag1 = -9;
  for (i=0;i<n;i++){
    
    if (result[i]=='/' && flag0<0) flag0 = i;
    if (result[i]=='G' && flag0>0) flag1 = i;
    if (flag0>0 && flag1>flag0){
      strncpy(out,result+flag0,flag1-flag0);
      out[flag1-flag0]='\0';
      //printf("----+++  %d) %s \n",flag1-flag0, out);
      
      if (flag1-flag0==36){
	t = atoi(out+1);
	th = t/10000;
	tm = (t/100)%100;
	ts = t%100;

	sscanf(out+8,"%f",&lad);
	//printf("lad: [%s] %07.2f \n", out+8, lad);
	sscanf(out+17,"%f",&lng);
	//printf("lng: [%s] %08.2f \n", out+17, lng);
	t = atoi(out+30);
	//sscanf(out+30,"%d",&t);
	//printf("alt: [%s] %06d \n", out+30, t);
	

	printf("  %02d:%02d:%02d   %07.2f  %08.2f  %06d \n", 
	       th, tm, ts, lad, lng, t);
	fprintf(fpOutStrip,"  %02d:%02d:%02d   %07.2f  %08.2f  %06d \n", 
	       th, tm, ts, lad, lng, t);
	fflush(fpOutStrip);

      }
      flag0 = flag1 = -9;
    }
    if (flag1-flag0> 40) flag0 = flag1 = -9;
  }
}




main(int argc, char *argv[]){


  int raw = 0;
  int i;
  
  for (i=0;i<argc;i++){
    if (strcmp(argv[i],"-r")==0) raw = 1;
  }


  // open output file with unique name
  char outFile[100];
  time_t mytime;
  struct tm *ltime;
  mytime = time(NULL);
  printf(ctime(&mytime));
  ltime = localtime(&mytime); 
  sprintf(outFile, "./GreenCube_%02d-%02d-%04d_%02d:%02d:%02d.dat\0",
	  ltime->tm_mon+1,  ltime->tm_mday, ltime->tm_year+1900,
	  ltime->tm_hour, ltime->tm_min,  ltime->tm_sec);
  printf("outfile:  %s\n", outFile);
  fpOutRaw = fopen(outFile,"w");
  fpOutStrip = fopen("GreenCube.dat","w");


  char buffer[100];
  int bytesRead, j;
  int fd;
  fd = open(/*"/dev/tty.usbmodemfd131"*/argv[1],(O_RDONLY | O_NOCTTY | O_NDELAY));
  fcntl(fd, F_SETFL, 0);
  //init port==================
  struct termios options;
  // Get the current options for the port...
  tcgetattr(fd, &options);
  // Set the baud rates to 115200...
  cfsetispeed(&options, B115200);
  cfsetospeed(&options, B115200);
  // Enable the receiver and set local mode...
  options.c_cflag |= (CLOCAL | CREAD);
  options.c_cflag &= ~PARENB;
  options.c_cflag &= ~CSTOPB;
  options.c_cflag &= ~CSIZE;
  options.c_cflag |= CS8;
  //cfmakeraw(&options);
  //options.c_iflag &= INLCR;
  // Set the new options for the port...
  tcsetattr(fd, TCSANOW, &options);
  //  end init port==================
  



  char result[254];
  int iRawCh, k;
  fcntl(fd, F_SETFL, FNDELAY); // don't block serial read
  j = 0;
  while(j>-1){
    iRawCh = read(fd, result, 1);
    if (iRawCh>0){
      //result[iRawCh-1] = '\n';
      for (k=0;k<iRawCh;k++) {
        /*if (result[k]<32) {
            result[k]=32;
        }*/
        //-------
        if (result[k] == '\n') {
            result[k] = 0xD;
        }
        //-------
      }
      
      fprintf(fpOutRaw, "%s", result);
      fflush(fpOutRaw);

      strip(result, iRawCh);

      j++;
    }
    else 
      usleep(1000000);
  }	  

  close(fd);

}
